import java.util.Arrays;
import java.util.Map;

public class DemoMan {

  /**
   * @param args 
   * [optional] An integer number to set in one of the arrays
   * [optional] Extra names to add to the NameList
   */
  public static void main(String[] args) {
    int firstNameArg = 0;
    
    // Arrays and cloning
    
    IntBean[] foo = new IntBean[] {new IntBean(1),new IntBean(2), new IntBean(3)};
    System.out.print("Array foo: ");
    for (IntBean b: foo) {
      System.out.print(b+" ");
    }
    System.out.println();
    
    IntBean[] bar = foo.clone();
    int val = 99;
    if (args.length != 0) {
      try {
        val = Integer.parseInt(args[0]);
        System.out.println("First program argument is numeric.");
        firstNameArg = 1;
      } catch (NumberFormatException e) {
        System.out.println("First program argument is non-numeric.");
      }
      System.out.println("Setting bar[0] to "+val);
      bar[0].setMyNumber(val);      
    }
    
    System.out.print("Array foo : ");
    System.out.print(Arrays.toString(bar));

    System.out.println("\n---------------\n");
    
    System.out.println("clamp -3: "+clamp(-3,new int[] {1,5}));
    System.out.println("clamp  1: "+clamp(1,new int[] {1,5}));
    System.out.println("clamp  6: "+clamp(6,new int[] {1,5}));
    System.out.println("\n---------------\n");

    // Collections
    
    NameList folks = new NameList();
    folks.addName("Rocky");
    
    for (int i=firstNameArg; i<args.length; i++) {
      folks.addName(args[i]);
      System.out.println("Added ["+args[i]+"]");      
    }
    
    System.out.println("\nThe names in the list are:");
    System.out.println(folks.getCsNameList());
    
    System.out.println("\nThe number of times each character appears in these names is:");
    Map<Character,Integer> cMap = folks.getCharacterMap();
    for (char c : cMap.keySet()) {
      System.out.println(c+" occurs "+cMap.get(c)+" times.");
    }
  }
  
  /**
   * Clamp a value within a range
   * @param x the int value to clamp
   * @param range the 2-element int[] giving the lower and upper bounds
   */
  private static int clamp(int x, int[] range) {
    return Math.min(Math.max(range[0],x),range[1]);  
  }
}
