import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;

public class FileReadMan {

  /**
   * @param args the name of the file to read
   */
  public static void main(String[] args) {
    if (args.length == 0) {
      System.out.println("Supply name of at least one file to read.");
      return;
    }

    for (String fileName : args) {
      System.out.println("-------------");
      System.out.println("-- "+fileName);
      System.out.println("-------------");
      try {
        BufferedReader in = new BufferedReader(new FileReader(fileName));
        String line = in.readLine();
        while (line != null) {
          int alphaCount = 0;
          int digitCount = 0;
          for (int i=0; i<line.length(); i++) {
            if (Character.isLetter(line.charAt(i))) alphaCount++;
            if (Character.isDigit(line.charAt(i))) digitCount++;
            
          }
          System.out.println(line.length()+" ("+alphaCount+","+digitCount+")\t"+line);
          line = in.readLine();
        }

      } catch (IOException e) {
        System.out.println(e);
      }
    }
  }
}
